import sys,os,string

class Log:
    def __init__(self,filename):

	if filename:
	    log_file=filename
	try:
	    self.__log_file = open(log_file, "r")
	except IOError, errmsg:
	    sys.exit(errmsg)

    def read(self):
	for line in self.__log_file.read().split("\n"):
	    yield line
	self.__log_file.close()

    def eval(self):
	pass
    
class CondLog(Log):

	def __init__(self,filename):
		Log.__init__(self,filename)

	def eval(self,search1,search2=None,cond=None):
		generic_value = None
		arch_spec_value = None
		obtained_value = cond
		
		for line in self.read():
		
			if search1 is not None and search1 in line:
				generic_value = line[8:-3]
				if search2 is None:
					return line
			elif search2 is not None and search2 in line:
				arch_spec_value = line[5:-3]


		if generic_value is None or arch_spec_value is None:
		    sys.exit("Invalid log format")
	
		flag=None
		if float(obtained_value) > float(generic_value):
		    print "FAIL1"
		    flag=1	
		if float(obtained_value) > float(arch_spec_value):
		    print "FAIL2"
		    flag=2
		if flag is None:
		    print "PASS"
		else:	
		    print "FAIL"


class SystemInfo:
    def __init__(self):
	self.machine_type=self.__machine_type__()

    def __machine_type__(self):
	op_string=os.popen("dmidecode | grep 'Product Name: IBM'").readline()
	if "LS20" in op_string:
	    return "LS20"

	if "LS21" in op_string:
	    return "LS21"

	if " 326" in op_string:
	    return "e326"

	if "x326" in op_string:
	    return "326m"
	return False
